class genericstatsystem expands Mutator;


// Declare our avalible achievement count!
// you must declare this in the default properties!
var int achevmentcount;

// Header tag for log messages
var string logheader; 
// Header for client messages
var string messageheader;


// Putting full command in word pieces
var string wordlist[500];

// Reference for chat      
var  playerpawn tempp;

// First join check
var string beentoldonce[64];

// Helper Objects
var databasehelper dbhelper;
var helperlibrary helperobj;

// Whatever Chars we use to denote a command in chat
var string EscapePhrase;

// Saved join urls + bits
// We use this to get the join password if needed later.
Struct urldata_structure
{
var() string url, ip,player; // assosiate ip with password + playername
};
var () config  array<urldata_structure> cached_player_urls;

//-----------------------------------------------------------------------------------
// Start the mutator up
//-----------------------------------------------------------------------------------
function PostBeginPlay()
{
    // force defined here for testing
	logheader = "[genericstatsystem]";
	messageheader = "";
	EscapePhrase = "/";
	//declare achvment count  > this has no effect! must be defined in defualts
	achevmentcount = 10;
	
	   
	log ("-----------------------------------------------------------------------------",stringtoname("------------"));
    log ("Starting up Generic stat system" $ " Command char ="$ EscapePhrase ,stringtoname(logheader));
    
	// Spawn our gamerules interceptor
	AddGameRules();
	
    // spawn database library
	dbhelper = spawn(class'databasehelper');
    if( dbhelper != None)
	{
	  log ("Database library Spawned",stringtoname(logheader));
	  dbhelper.addintvalue("system" , "serverstartups");

	}

	// spawn helper  library
	helperobj = spawn(class'helperlibrary');
	if( helperobj != None)
	{
	 log ("helperobj spawned",stringtoname(logheader));
	}
	
	// check to see if the command package is in server packages
	If (IsInPackageMap("genericstatclient"))
    {
	 log ("Client package not in serverpackages, Gonna try and add it",stringtoname(logheader));
	 addToPackagesMap("genericstatclient"); // we can ty , but we my fail.
	}




}


function AddGameRules()
{
	local genericstatsystemGR gr;

	gr = Spawn(class'genericstatsystemGR');
	gr.MutatorPtr = self;

	if (Level.Game.GameRules == None)
		Level.Game.GameRules = gr;
	else if (gr != None)
		Level.Game.GameRules.AddRules(gr);
		
		
		if (gr == none)
		{
		log ("Somthing went  wrong spawning the gamerules!" ,stringtoname(logheader));
		AddGameRules();
		}
}




// cache the prelogin url's
function xPrelogin(string Options,string PlayerName)
{
addurltocache(options , consolecommand("UGetIp"), playername);
//log("options look like " $ options $ "  user ip is " $ consolecommand("UGetIp"));
}




// save the prelogin url when a connection is established
function addurltocache (string url , string ip , string xplayer)
{
local int i;
                         if (Array_Size(cached_player_urls) < 1)
                           {i = 0;
                           }else{
                           i = Array_Size(cached_player_urls) -1;
                           }
	                     Array_Insert(cached_player_urls,Array_Size(cached_player_urls),1);
	                   	 cached_player_urls[i].url=url;
						 cached_player_urls[i].ip=ip;
						 cached_player_urls[i].player=xplayer;

}

// Catch inventory object as they are picked up
function bool mutateCanPickupInventory( Pawn Other, Inventory Inv)
{
     // Add them to the database
	 // We probably want to do this as a mod
     if (other != none && other.IsA('PlayerPawn'))
     {
     dbhelper.updatedatavalue (helperobj.getplayername(playerpawn(other)) $".inventory" , string(Inv.class),"has");
     return true;
	 }
return true;
}






// Catch any chat 
function bool handleChat( PlayerPawn Chatting, out string Msg )
{
local bool bfoundcommand;

   // note - brodcast messages are funnelled into this function as well.
   // none  could = map / system message


   // chat starts with escapephrase (/)
   if(chatting != None  && Left(msg, len(EscapePhrase)) == EscapePhrase &&  chatting.IsA('PlayerPawn'))
   {



          // implement some arbitrary command
          if(instr(msg,EscapePhrase $"test")!=-1)
          {
           chatting.ClientMessage("Test: echo!");
           bfoundcommand = true;
		   return false;
          }
		  
		  
		  if(instr(msg,EscapePhrase $"stats")!=-1)
          {
           playerstats(chatting);
           bfoundcommand = true;
		   return false;
          }


		  
		  if(instr(msg,EscapePhrase $ "nicksrv")!=-1)
		  {
		  nicksrv(msg);
		  bfoundcommand = true;
		  return false; 
		  }
		  
	      if(instr(msg,EscapePhrase $"createlogin ")!=-1)
		  { 
 	      bfoundcommand = true;
		  return false;
		  }
		  
	      if(instr(msg,EscapePhrase $"plogin ")!=-1)
		  { 
		  bfoundcommand = true;
		  return false;
		  
		  }

		  // If we dont honer the request null out.
		  if(instr(msg,"createlogin ")!=-1){ 	;	return false;      }
	      if(instr(msg,"plogin ")!=-1){ 	;	return false;      }
		  
		  
		  
          // dont brodcast this say message
          // keep in mind that further mutators will not be givin the chance to process if we do this.
          if (!bfoundcommand && chatting != none)
          {
          return false;
          chatting.ClientMessage("Invalid Command");
          }

          return false;



   }




 return true;
}


// some usless function to interact with nickserv
function nicksrv(string msg)
{
breakstring(msg, " ");
// some example here nickserv givecredit p# ammount
if (WordList[1] == "givecredit" &&  WordList[2] != "" && WordList[2] != " " )
{
//dbhelper.addintvalue(helperobj.getplayername(playerpawn(ender)) , "balance");
}
tempp.ClientMessage("opps this does work yet");

}

// player switchs level
function string mutatecooptravel(pawn ender,string nexturl)
{
  // Some player hit the ending
  // None = sever ender
     if (ender != none && ender.IsA('PlayerPawn'))
     {
       //log ("Player Ended : " $ helperobj.getplayeridfromp(ender) $ " going to  "$  nexturl);
       dbhelper.addintvalue(helperobj.getplayername(playerpawn(ender)) , "levelsended");
       return nexturl;
     }
return nexturl;
}


// spawn a deley object 
function spawnblockdelay(playerpawn p)
{
local delayedmutatehelper gr;
gr = Spawn(class'delayedmutatehelper');
gr.Mutateplayer = p;
gr.backlink = self;

}


// called when a player respawns / joins
function mutaterespwan( Pawn Spawner )
{
     local class<inventory> ItemClass;	
        // some player respawns
        // use for give inventory , spawn stats , help etc
    
	if( spawner.IsA('PlayerPawn') && spawner != none )
	{
	
	If (IsInPackageMap("genericstatclient"))
              {
	ItemClass = class<inventory>(DynamicLoadObject("genericstatclient.managerclient", class'Class'));
	//playerpawn(Spawner).ItemClass.touch(ItemClass);
	          }
	
	
        //log("player respawned");


         // one shot!
         if (beentoldonce[helperobj.getplayeridfromp(playerpawn(Spawner))] != "true")
         {
           beentoldonce[helperobj.getplayeridfromp(playerpawn(Spawner))] = "true";

           //delay the bs!
           spawnblockdelay(playerpawn(Spawner));

         }

        }


}



// save damage - this has potential issues
function checkDamage( Pawn victim, Pawn InstigatedBy, out int Damage, vector HitLocation, name DamageType, out vector Momentum )
{

    if (InstigatedBy !=None  && InstigatedBy.IsA('PlayerPawn') && (Victim != InstigatedBy) )
	{
		// When player shoot a monster
		if( Victim.IsA('scriptedpawn'))
		{

		// if you save this "damage", you should divide damage , or concat into string.
		// you will hit integer max soon enough

		}
    }

}

// called any time somthing is killed
function xscoreKilled(Pawn Killed, Pawn Killer, name DamageType)
{

    if (Killer !=None  && Killer.IsA('PlayerPawn') && !killed.IsA('PlayerPawn'))
	{ // player killed a scriptedpawn/bot , ignoring freidly or self kills
     dbhelper.addintvalue(helperobj.getplayername(playerpawn(Killer)) $".Killstats" , string(Killed.class));
	}


}






function breakstring(string cmd,string breakerdelimiter)
{ // some function to un-concat divided strings.
  // dumps to wordlist

    local int i, words;
   cmd=cmd$breakerdelimiter;
   for(i=0;i<500;i++)
   {
     if (i > 499) break;
	 WordList[i]="";
   }
  while ((len(cmd)) > 1)
   {      while(left(cmd,1) != breakerdelimiter )
       { wordlist[words]=wordlist[words]$left(cmd,1);
        cmd=right(cmd,len(cmd)-1);}
     // found one word....
     cmd=right(cmd,len(cmd)-1);
     if ( (wordlist[words]!=breakerdelimiter)&&(wordlist[words]!="") )  words++;  // ignore " " / "" as word itself
   } // end while len(Command) > 1)
  cmd="";
  // executing commands
}





// called from pickup
function createaccount(playerpawn p,string args)
{
  breakstring(args, " ");


 // no data for account

 if (dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"password") != "nil")
 {

    // change password to second arg
    if (dbhelper.getdatavalue ( helperobj.getplayername(p) $".nickserv" ,"password") == wordlist[0]
        && wordlist[0] != "" && wordlist[0] != " " && wordlist[1] != "" && wordlist[1] != " "
        )
    {
     dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "password",wordlist[1]);
     p.ClientMessage(messageheader $" Password changed! ");
     p.ClientMessage(messageheader $" you login password is now " $ wordlist[1]);
     p.ClientMessage(messageheader $" you login password was " $ wordlist[0]);
     p.ClientMessage(messageheader $" To athenticate in future, type plogin " $ args);
     p.ClientMessage(messageheader $" Your hash " $ consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
     dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "identity",consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
     log(messageheader $ helperobj.getplayername(p) $ "changed there account password",stringtoname(logheader));
     accountlogin(p,wordlist[1]);
    return;
    }

    // account exists already
    // dont allow overide existing acconts

    if (	dbhelper.getdatavalue ( helperobj.getplayername(p) $".nickserv" ,"password") == args
            && args != "" && args != " "
        )
    {
    // some matching user/password
    p.ClientMessage(messageheader $" you accounts already registered.  Type createaccount <oldpass> <newpass>  to change password.");
    p.ClientMessage(messageheader $" some account security info here.");
    //p.ClientMessage("[nicksrv] the last login to this account was on &date& on *ip*");
    }else{
    // this accounts arlready registed, please /login or use another name
    p.ClientMessage(messageheader $" nick already in use!");
    log(messageheader $" "$ helperobj.getplayername(p) $ " tried to make a account using a unavalibe nick",stringtoname(logheader));
    }

 }


 if (	dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"password") == "nil" && args != "" && args != " ")
 {
  dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "password",args);
  dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "identity",consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
  p.ClientMessage(messageheader $" nick "  $ helperobj.getplayername(p) $ " has been registered");
  p.ClientMessage(messageheader $" you login password is now " $ args);
  p.ClientMessage(messageheader $" to athenticate in future, type plogin " $ args);
  p.ClientMessage(messageheader $" your hash" $ consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
  log(helperobj.getplayername(p) $ " registered there account",helperobj.stringtoname(logheader));
 }



}



function accountlogin(playerpawn p,string args)
{



 if (dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"password") == "nil")
 {
  p.ClientMessage("Your nick is not registered on this server.");
 }else{
 
      if (isaccountlocked(p))
      {
      p.ClientMessage(messageheader $" to many password Attempts, Account locked");
      p.ClientMessage(messageheader $" contact a admin for assistance in unlocking your account.");
      return;
      }
	  
	  
	  if (isaccountbanned(p))
      {
      p.ClientMessage(messageheader $" Your account has been banned!");
      p.Destroy();
      return;
      }
 
 
 

   //  nick is registersed?
   if (	dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" ,"password") == args)
   {
  
     if (isvaladatedp(p))
     {// player already logged in
       p.ClientMessage(messageheader $" Your already logged in");
       showaccountinfo(p);

     }else{
      p.ClientMessage(messageheader $" Password ok., updating session id");
      dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "identity",consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
      dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "lastip",consolecommand("ugetplayerip " $ helperobj.getplayeridfromp(p)));
      dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "loginattemps","0");
      authuseratjoin(p);
     }
  
  
  
   }else{

   p.ClientMessage(messageheader $" Invalid password.");

   }

 }





}

function authuseratjoin(playerpawn p)
{
local string gg;
local string cachedplayeridfromdb; //performance

            gg=consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p));

           // check if you have a account
           if (	dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" ,"password") == "nil")
           {
           p.ClientMessage(messageheader $" your nick is not registered.");
           p.ClientMessage(messageheader $" createlogin <pass>  to register your nick.");
           log(messageheader $" no registered nick");
           }

           // check if our uid is fucked
           if (gg ==" " || gg == "")
           {
           p.ClientMessage(messageheader $" cant get client indentity!");
           log(" player " $ helperobj.getplayername(p) $ " bad uid return");
           }



            if (isaccountlocked(p))
            {
              p.ClientMessage(messageheader $" Warning ! your account was marked as locked!");
              p.ClientMessage(messageheader $" the last  ip to fail login : " $ dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"lastip"));
              dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "loginattemps","0");
              p.ClientMessage(messageheader $"  locked flag removed.!");
            }
			
			
			//join password
            if (fetchloginpassword(p)  == dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" ,"password")
             && fetchloginpassword(p) != "" && fetchloginpassword(p) != " "
             && dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" ,"password") != "nil")
            {
             p.ClientMessage(messageheader $ " join Password ok ., updating session id");
			 log("[Nicksrv]: join Password ok ., updating session id");
             dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "identity",consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(p)));
             dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "lastip",consolecommand("ugetplayerip " $ helperobj.getplayeridfromp(p)));
             dbhelper.updatedatavalue (helperobj.getplayername(p) $".nickserv" , "loginattemps","0");

            }
			

          cachedplayeridfromdb=dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"identity");
          // possible exploit - if change name in first second

           // check if your uid matched stored
           if (	cachedplayeridfromdb != "nil"
               && cachedplayeridfromdb == gg
               && cachedplayeridfromdb != ""
               && cachedplayeridfromdb != " ")
           {
            p.ClientMessage(messageheader $ " found identity " $ dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"identity"));
            log("nickserv: found nick identity");


               if (dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"admingroup") != "nil")
               {

                      if (dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"admingroup") == "1")
                      {
                       p.badmin = true;
                       log(" player " $ helperobj.getplayername(p) $ "admin group 1");
                       p.ClientMessage(messageheader $" administrative group 1");
                      }

               }else{

                      p.ClientMessage(messageheader $" no administrative group  assigned");
                      log(messageheader $" no admin group!");
               }


           }


           // fail if identity dont match
           if (	cachedplayeridfromdb != "nil"
               && cachedplayeridfromdb != gg )
           {
            log("nickserv: stale session");
            p.ClientMessage(messageheader $" could not validate your account : (Client hash changed)");
            p.ClientMessage(messageheader $" please plogin with your password to reestablish session");

           }




}





function showaccountinfo(playerpawn p)
{
 p.ClientMessage(messageheader $" last login ip " $ dbhelper.getdatavalue(helperobj.getplayername(p) $".nickserv" ,"lastip"));


}

function bool isaccountlocked(playerpawn p)
{

// password failures
   if (dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" , "loginattemps")  != "nil")
      {
            if (int(dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" , "loginattemps")) > 5)
            {
            return true;
            }
      }

return false;
}


function bool  isaccountbanned(playerpawn p)
{

   //return true for ban - value = reason
   if (dbhelper.getdatavalue (helperobj.getplayername(p) $".nickserv" , "banned")  != "nil")
      {
        p.ClientMessage(messageheader $" " $ dbhelper.getdatavalue (helperobj.getplayername(p) $ ".nickserv" , "banned"));
      return true;

      }

return false;
}


function bool isvaladatedp(playerpawn spawner)
{
 if (dbhelper.getdatavalue (helperobj.getplayername(Spawner) $".nickserv" ,"identity") != "nil"
    && dbhelper.getdatavalue(helperobj.getplayername(Spawner) $".nickserv" ,"identity") == consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(Spawner))
    && consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(Spawner)) != ""
    && consolecommand("ugetplayeridentity " $ helperobj.getplayeridfromp(Spawner)) != " ")
    {
    return true;
    }
    return false;
 }


function bool bhasaccount(playerpawn spawner)
{
 if (dbhelper.getdatavalue (helperobj.getplayername(Spawner) $".nickserv" ,"identity") != "nil")
    {
    return true;
    }
    return false;
 }


function playerstats(playerpawn p)
{
local string localbs,values,dodgebs;
local int i,achivemintcount,avalibleachevments;
local mutator mut;


 if (!bhasaccount(p))
 {
 p.ClientMessage("you need to register a account to use this feature!");
 p.ClientMessage("register a account");
 return;
 }

	 localbs = dbhelper.concatgroups (helperobj.getplayername(p)$".Killstats");
     breakstring(localbs," ");
     For( i = 0; i <  200 ; i++  )
     {
       if (wordlist[i] != "" && wordlist[i] != " " && wordlist[i] != "nil")
       {
       values =  dbhelper.getdatavalue (helperobj.getplayername(p)$".Killstats" , wordlist[i]);
        if (values != "nil")
        {
          p.ClientMessage("killed " $ values $ " " $ wordlist[i]);
        }
       }

     }


        values = dbhelper.getdatavalue (helperobj.getplayername(p) , "levelsended");
        if (values != "nil")
        {
          p.ClientMessage("Levels ended by you " $ values);
        }else{
          p.ClientMessage("Levels ended by you " $ values);
        }

		
		
	  localbs = dbhelper.concatgroups (helperobj.getplayername(tempp)$".achivments");
      breakstring(localbs," ");
    
      log (localbs);
      For( i = 0; i <  200 ; i++  )
     {
       if (wordlist[i] != "" && wordlist[i] != " " && wordlist[i] != "nil")
       {

         values =  dbhelper.getdatavalue (helperobj.getplayername(tempp)$".achivments" , wordlist[i]);
        if (values != "nil")
        {
          tempp.ClientMessage("" $ wordlist[i] $ "  " $values);
          achivemintcount ++;
        }


       }


     }	
		
		
		
		

   
     // try to get avalible achevments from other mods!
     // this is a clever hack !
     foreach AllActors(Class'mutator',mut)
   	 {
   	      dodgebs = "0";
    	  dodgebs = consolecommand("get "$string(mut.class) $" achevmentcount");
    	  //log(dodgebs);
   	      if (dodgebs != "" && dodgebs != " " && instr(dodgebs,"Unrecognized")==-1 )
   	      {
   	      //log("yes " $ dodgebs);
   	      //Unrecognized property
   	      tempp.ClientMessage("Mod "$ string(mut.class)$ " adds " $ dodgebs $ " achevments" );
   	      avalibleachevments  = avalibleachevments + int(dodgebs);
   	      }
   	 }
   



}


function string fetchloginpassword(playerpawn p)
{
  local int i;
  local string pass;
  local string bfound;
   For( i = 0; i <  Array_Size(cached_player_urls) ; i++  )
    {
                          // check ther ip + username from prelogin
                          if (cached_player_urls[i].player == helperobj.getplayername(p) && consolecommand("ugetplayerip " $ helperobj.getplayeridfromp(p)) == cached_player_urls[i].ip)
					      {
					        // last entry!
                            pass = helperobj.ParseOption(cached_player_urls[i].url, "Password");
                            log ("Fetched password ="$pass);

                          }


    }
    return pass;
}

